#!/usr/bin/env python
# test_mc_annotate.py

"""
Author: Sandra Smit (Sandra.Smit@colorado.edu)

Revision History:
File created on 30 Jul 2007.

"""
from __future__ import division
from cogent.util.unit_test import TestCase, main
from cogent.parse.rnaview import Base, BasePair, BasePairs
from mcann import parse_bp, McAnnotateParser

class McAnnotateTests(TestCase):

    def est_parse_bp(self):
        l = '{A57R:G -> A355R:C: pairing antiparallel cis XIX Ww/Ww }'
        b1 = Base('A','57','G')
        b2 = Base('A','355','C')
        exp_bp = BasePair(b1, b2, Edges="Ww/Ww", Orientation='cis',\
            Conformation='antiparallel', Saenger='XIX')
        self.assertEqual(parse_bp(l), exp_bp)

    def test_McAnnotateParser(self):
        lines = SAMPLE.split('\n')
        obs = McAnnotateParser(lines)
        print obs

OLD_SAMPLE=\
"""{A5R:U -> A6R:G: adjacent_5p pairing parallel cis one_hbond Ss/Ww }
{A9R:G -> A25R:C: pairing antiparallel cis XIX Ww/Ww }
{A10R:A -> A24R:U: pairing antiparallel cis XX Ww/Ww }
{A11R:G -> A23R:C: pairing antiparallel cis XIX Ww/Ww }
{A12R:U -> A22R:G: pairing antiparallel cis XXVIII Ws/Ww }
{A13R:U -> A20R:U: pairing antiparallel trans one_hbond 81 Hw/Ww }
{A13R:U -> A915R:A: pairing parallel cis XXIII Ww/Hh }
{A15R:G -> A920R:U: pairing antiparallel cis XXVIII Ww/Ws }
{A16R:A -> A919R:A: pairing antiparallel cis 37 Ww/Ww }
{A17R:U -> A918R:A: pairing antiparallel cis XX Ww/Ww }
{A18R:C -> A917R:G: pairing antiparallel cis XIX Ww/Ww }
"""

SAMPLE="""
# Base interactions for file: ../1EHZ.pdb
A,1,R:G!!A,72,R:C!!{A1R:G -> A72R:C: pairing antiparallel cis XIX Ww/Ww }
A,2,R:C!!A,71,R:G!!{A2R:C -> A71R:G: pairing antiparallel cis XIX Ww/Ww }
A,3,R:G!!A,70,R:C!!{A3R:G -> A70R:C: pairing antiparallel cis XIX Ww/Ww }
A,4,R:G!!A,69,R:U!!{A4R:G -> A69R:U: pairing antiparallel cis XXVIII Ww/Ws }
A,5,R:A!!A,68,R:U!!{A5R:A -> A68R:U: pairing antiparallel cis XX Ww/Ww }
A,6,R:U!!A,67,R:A!!{A6R:U -> A67R:A: pairing antiparallel cis XX Ww/Ww }
A,7,R:U!!A,66,R:A!!{A7R:U -> A66R:A: pairing antiparallel cis XX Ww/Ww }
A,8,R:U!!A,14,R:A!!{A8R:U -> A14R:A: pairing antiparallel trans XXIV Ww/Hh }

 ,1,R:A!! ,72,R:U!!{1R:A -> 72R:U: pairing antiparallel cis XX Ww/Ww }
 ,2,R:G!! ,71,R:C!!{2R:G -> 71R:C: pairing antiparallel cis XIX Ww/Ww }
"""

if __name__ == "__main__":
    main()
