#!/usr/bin/env python
# test_constraint.py

"""
Author: Sandra Smit (Sandra.Smit@colorado.edu)

Revision History:

"""
from __future__ import division
from cogent.util.unit_test import TestCase, main
from constraint import *
from cogent.struct.rna2d import Pairs
from numpy import arange
from random import choice

class TestConstraints(TestCase):

    def test_constraint_A(self):
        p = Pairs([(1,10),(2,9),(3,8),(12,18)])
        for x in range(10):
            f = choice(arange(0.1, 1.0,0.05))
            print constraint_A(p, 25, frac=f), f

    def test_constraint_B(self):
        p = Pairs([(1,10),(2,9),(3,8),(12,18),(13,17),(20,0)])
        for x in range(10):
            f = choice(arange(0.1, 1.0,0.05))
            print constraint_B(p, 25, frac=f), f

    def test_constraint_C(self):
        p = Pairs([(1,10),(2,9),(3,8),(12,18),(13,17),(20,0),(22,28),(23,27)])
        for x in range(10):
            f = choice(arange(0.1, 1.0,0.05))
            print constraint_C(p, 30, frac=f), f

    def test_constraint_D(self):
        p = Pairs([(1,10),(2,9),(3,8),(12,18),(13,17),(20,0),(22,28),(23,27)])
        for x in range(10):
            f = choice(arange(0.1, 1.0,0.05))
            print constraint_D(p, 30, frac=f), f

    def test_constraint_E(self):
        p = Pairs([(1,10),(2,9),(3,8),(12,18),(13,17),(20,0),(22,28),(23,27)])
        for x in range(10):
            f = choice(arange(0.1, 1.0,0.05))
            print constraint_E(p, 30, frac=f), f

    def test_constraint_F(self):
        p = Pairs([(1,10),(2,9),(3,8),(12,18),(13,17),(20,0),(22,28),(23,27)])
        for x in range(10):
            f = choice(arange(0.1, 1.0,0.05))
            print constraint_F(p, 30, frac=f), f



if __name__ == "__main__":
    main()
