#!/usr/bin/env python

"""Contains miscellaneous functions.

Revision History:
9/18/06 Sandra Smit: added all_perms.
"""

def all_perms(seq):
    """Yield all permutations of a sequence.

    Recipe: http://aspn.activestate.com/ASPN/Cookbook/Python/Recipe/252178
    """
    if len(seq) <=1:
        yield seq
    else:
        for perm in all_perms(seq[1:]):
            for i in range(len(perm)+1):
                yield perm[:i] + seq[0:1] + perm[i:]

